import { ITreeNodeData } from "../interfaces/ITreeNodeData";
export declare abstract class AbstractTreeNodeData implements ITreeNodeData {
    #private;
    /**
     * Creates a tree node data object.
     *
     * @param id Id of this data object
     */
    constructor(id?: string, version?: string);
    get convertedObject(): {
        [key: string]: unknown;
    };
    set convertedObject(value: {
        [key: string]: unknown;
    });
    get id(): string;
    get updateCallback(): ((newVersion: string, oldVersion: string) => void) | null;
    set updateCallback(value: ((newVersion: string, oldVersion: string) => void) | null);
    get updateCallbackConvertedObject(): ((newObj: unknown, oldObj: unknown, viewport: string) => void) | null;
    set updateCallbackConvertedObject(value: ((newObj: unknown, oldObj: unknown, viewport: string) => void) | null);
    get version(): string;
    /**
     * Clones the tree node data.
     */
    clone(): ITreeNodeData;
    /**
     * Update the version
     */
    updateVersion(): void;
}
//# sourceMappingURL=AbstractTreeNodeData.d.ts.map